----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    16:55:29 05/14/2013 
-- Design Name: 
-- Module Name:    top - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity top is
	 PORT(
			mcb3_dram_dq : INOUT  std_logic_vector(15 downto 0);
			mcb3_dram_a : OUT  std_logic_vector(13 downto 0);
			mcb3_dram_ba : OUT  std_logic_vector(2 downto 0);
			mcb3_dram_ras_n : OUT  std_logic;
			mcb3_dram_cas_n : OUT  std_logic;
			mcb3_dram_we_n : OUT  std_logic;
			mcb3_dram_odt : OUT  std_logic;
			mcb3_dram_reset_n : OUT  std_logic;
			mcb3_dram_cke : OUT  std_logic;
			mcb3_dram_dm : OUT  std_logic;
			mcb3_dram_udqs : INOUT  std_logic;
			mcb3_dram_udqs_n : INOUT  std_logic;
			mcb3_rzq : INOUT  std_logic;
			mcb3_zio : INOUT  std_logic;
			mcb3_dram_udm : OUT  std_logic;
			c3_sys_clk : IN  std_logic;
			c3_sys_rst_i : IN  std_logic;
			c3_calib_done : OUT  std_logic;
			c3_clk0 : OUT  std_logic;
			c3_rst0 : OUT  std_logic;
			mcb3_dram_dqs : INOUT  std_logic;
			mcb3_dram_dqs_n : INOUT  std_logic;
			mcb3_dram_ck : OUT  std_logic;
			mcb3_dram_ck_n : OUT  std_logic;
			c3_s0_axi_aclk : IN  std_logic;
			c3_s0_axi_aresetn : IN  std_logic;
			c3_s0_axi_awid : IN  std_logic_vector(0 downto 0);
			c3_s0_axi_awaddr : IN  std_logic_vector(31 downto 0);
			c3_s0_axi_awlen : IN  std_logic_vector(7 downto 0);
			c3_s0_axi_awsize : IN  std_logic_vector(2 downto 0);
			c3_s0_axi_awburst : IN  std_logic_vector(1 downto 0);
			c3_s0_axi_awlock : IN  std_logic_vector(0 downto 0);
			c3_s0_axi_awcache : IN  std_logic_vector(3 downto 0);
			c3_s0_axi_awprot : IN  std_logic_vector(2 downto 0);
			c3_s0_axi_awqos : IN  std_logic_vector(3 downto 0);
			c3_s0_axi_awvalid : IN  std_logic;
			c3_s0_axi_awready : OUT  std_logic;
			c3_s0_axi_wdata : IN  std_logic_vector(31 downto 0);
			c3_s0_axi_wstrb : IN  std_logic_vector(3 downto 0);
			c3_s0_axi_wlast : IN  std_logic;
			c3_s0_axi_wvalid : IN  std_logic;
			c3_s0_axi_wready : OUT  std_logic;
			c3_s0_axi_bid : OUT  std_logic_vector(0 downto 0);
			c3_s0_axi_wid : OUT  std_logic_vector(0 downto 0);
			c3_s0_axi_bresp : OUT  std_logic_vector(1 downto 0);
			c3_s0_axi_bvalid : OUT  std_logic;
			c3_s0_axi_bready : IN  std_logic;
			c3_s0_axi_arid : IN  std_logic_vector(0 downto 0);
			c3_s0_axi_araddr : IN  std_logic_vector(31 downto 0);
			c3_s0_axi_arlen : IN  std_logic_vector(7 downto 0);
			c3_s0_axi_arsize : IN  std_logic_vector(2 downto 0);
			c3_s0_axi_arburst : IN  std_logic_vector(1 downto 0);
			c3_s0_axi_arlock : IN  std_logic_vector(0 downto 0);
			c3_s0_axi_arcache : IN  std_logic_vector(3 downto 0);
			c3_s0_axi_arprot : IN  std_logic_vector(2 downto 0);
			c3_s0_axi_arqos : IN  std_logic_vector(3 downto 0);
			c3_s0_axi_arvalid : IN  std_logic;
			c3_s0_axi_arready : OUT  std_logic;
			c3_s0_axi_rid : OUT  std_logic_vector(0 downto 0);
			c3_s0_axi_rdata : OUT  std_logic_vector(31 downto 0);
			c3_s0_axi_rresp : OUT  std_logic_vector(1 downto 0);
			c3_s0_axi_rlast : OUT  std_logic;
			c3_s0_axi_rvalid : OUT  std_logic;
			c3_s0_axi_rready : IN  std_logic
		  );
end top;

architecture Behavioral of top is

	COMPONENT mig
		 PORT(
				mcb3_dram_dq : INOUT  std_logic_vector(15 downto 0);
				mcb3_dram_a : OUT  std_logic_vector(13 downto 0);
				mcb3_dram_ba : OUT  std_logic_vector(2 downto 0);
				mcb3_dram_ras_n : OUT  std_logic;
				mcb3_dram_cas_n : OUT  std_logic;
				mcb3_dram_we_n : OUT  std_logic;
				mcb3_dram_odt : OUT  std_logic;
				mcb3_dram_reset_n : OUT  std_logic;
				mcb3_dram_cke : OUT  std_logic;
				mcb3_dram_dm : OUT  std_logic;
				mcb3_dram_udqs : INOUT  std_logic;		--// for X16 parts 
				mcb3_dram_udqs_n : INOUT  std_logic;	--// for X16 parts 
				mcb3_rzq : INOUT  std_logic;
				mcb3_zio : INOUT  std_logic;
				mcb3_dram_udm : OUT  std_logic;			--// for X16 parts 
				c3_sys_clk : IN  std_logic;
				c3_sys_rst_i : IN  std_logic;
				c3_calib_done : OUT  std_logic;
				c3_clk0 : OUT  std_logic;
				c3_rst0 : OUT  std_logic;
				mcb3_dram_dqs : INOUT  std_logic;
				mcb3_dram_dqs_n : INOUT  std_logic;
				mcb3_dram_ck : OUT  std_logic;
				mcb3_dram_ck_n : OUT  std_logic;
				c3_s0_axi_aclk : IN  std_logic;
				c3_s0_axi_aresetn : IN  std_logic;
				c3_s0_axi_awid : IN  std_logic_vector(0 downto 0);
				c3_s0_axi_awaddr : IN  std_logic_vector(31 downto 0);
				c3_s0_axi_awlen : IN  std_logic_vector(7 downto 0);
				c3_s0_axi_awsize : IN  std_logic_vector(2 downto 0);
				c3_s0_axi_awburst : IN  std_logic_vector(1 downto 0);
				c3_s0_axi_awlock : IN  std_logic_vector(0 downto 0);
				c3_s0_axi_awcache : IN  std_logic_vector(3 downto 0);
				c3_s0_axi_awprot : IN  std_logic_vector(2 downto 0);
				c3_s0_axi_awqos : IN  std_logic_vector(3 downto 0);
				c3_s0_axi_awvalid : IN  std_logic;
				c3_s0_axi_awready : OUT  std_logic;
				c3_s0_axi_wdata : IN  std_logic_vector(31 downto 0);
				c3_s0_axi_wstrb : IN  std_logic_vector(3 downto 0);
				c3_s0_axi_wlast : IN  std_logic;
				c3_s0_axi_wvalid : IN  std_logic;
				c3_s0_axi_wready : OUT  std_logic;
				c3_s0_axi_bid : OUT  std_logic_vector(0 downto 0);
				c3_s0_axi_wid : OUT  std_logic_vector(0 downto 0);
				c3_s0_axi_bresp : OUT  std_logic_vector(1 downto 0);
				c3_s0_axi_bvalid : OUT  std_logic;
				c3_s0_axi_bready : IN  std_logic;
				c3_s0_axi_arid : IN  std_logic_vector(0 downto 0);
				c3_s0_axi_araddr : IN  std_logic_vector(31 downto 0);
				c3_s0_axi_arlen : IN  std_logic_vector(7 downto 0);
				c3_s0_axi_arsize : IN  std_logic_vector(2 downto 0);
				c3_s0_axi_arburst : IN  std_logic_vector(1 downto 0);
				c3_s0_axi_arlock : IN  std_logic_vector(0 downto 0);
				c3_s0_axi_arcache : IN  std_logic_vector(3 downto 0);
				c3_s0_axi_arprot : IN  std_logic_vector(2 downto 0);
				c3_s0_axi_arqos : IN  std_logic_vector(3 downto 0);
				c3_s0_axi_arvalid : IN  std_logic;
				c3_s0_axi_arready : OUT  std_logic;
				c3_s0_axi_rid : OUT  std_logic_vector(0 downto 0);
				c3_s0_axi_rdata : OUT  std_logic_vector(31 downto 0);
				c3_s0_axi_rresp : OUT  std_logic_vector(1 downto 0);
				c3_s0_axi_rlast : OUT  std_logic;
				c3_s0_axi_rvalid : OUT  std_logic;
				c3_s0_axi_rready : IN  std_logic
			  );
		 END COMPONENT;
	 
begin

   Test_MIG : mig PORT MAP (
          mcb3_dram_dq => mcb3_dram_dq,
          mcb3_dram_a => mcb3_dram_a,
          mcb3_dram_ba => mcb3_dram_ba,
          mcb3_dram_ras_n => mcb3_dram_ras_n,
          mcb3_dram_cas_n => mcb3_dram_cas_n,
          mcb3_dram_we_n => mcb3_dram_we_n,
          mcb3_dram_odt => mcb3_dram_odt,
          mcb3_dram_reset_n => mcb3_dram_reset_n,
          mcb3_dram_cke => mcb3_dram_cke,
          mcb3_dram_dm => mcb3_dram_dm,
          mcb3_dram_udqs => mcb3_dram_udqs,
          mcb3_dram_udqs_n => mcb3_dram_udqs_n,
          mcb3_rzq => mcb3_rzq,
          mcb3_zio => mcb3_zio,
          mcb3_dram_udm => mcb3_dram_udm,
          c3_sys_clk => c3_sys_clk,
          c3_sys_rst_i => c3_sys_rst_i,
          c3_calib_done => c3_calib_done,
          c3_clk0 => c3_clk0,
          c3_rst0 => c3_rst0,
          mcb3_dram_dqs => mcb3_dram_dqs,
          mcb3_dram_dqs_n => mcb3_dram_dqs_n,
          mcb3_dram_ck => mcb3_dram_ck,
          mcb3_dram_ck_n => mcb3_dram_ck_n,
          c3_s0_axi_aclk => c3_s0_axi_aclk,
          c3_s0_axi_aresetn => c3_s0_axi_aresetn,
          c3_s0_axi_awid => c3_s0_axi_awid,
          c3_s0_axi_awaddr => c3_s0_axi_awaddr,
          c3_s0_axi_awlen => c3_s0_axi_awlen,
          c3_s0_axi_awsize => c3_s0_axi_awsize,
          c3_s0_axi_awburst => c3_s0_axi_awburst,
          c3_s0_axi_awlock => c3_s0_axi_awlock,
          c3_s0_axi_awcache => c3_s0_axi_awcache,
          c3_s0_axi_awprot => c3_s0_axi_awprot,
          c3_s0_axi_awqos => c3_s0_axi_awqos,
          c3_s0_axi_awvalid => c3_s0_axi_awvalid,
          c3_s0_axi_awready => c3_s0_axi_awready,
          c3_s0_axi_wdata => c3_s0_axi_wdata,
          c3_s0_axi_wstrb => c3_s0_axi_wstrb,
          c3_s0_axi_wlast => c3_s0_axi_wlast,
          c3_s0_axi_wvalid => c3_s0_axi_wvalid,
          c3_s0_axi_wready => c3_s0_axi_wready,
          c3_s0_axi_bid => c3_s0_axi_bid,
          c3_s0_axi_wid => c3_s0_axi_wid,
          c3_s0_axi_bresp => c3_s0_axi_bresp,
          c3_s0_axi_bvalid => c3_s0_axi_bvalid,
          c3_s0_axi_bready => c3_s0_axi_bready,
          c3_s0_axi_arid => c3_s0_axi_arid,
          c3_s0_axi_araddr => c3_s0_axi_araddr,
          c3_s0_axi_arlen => c3_s0_axi_arlen,
          c3_s0_axi_arsize => c3_s0_axi_arsize,
          c3_s0_axi_arburst => c3_s0_axi_arburst,
          c3_s0_axi_arlock => c3_s0_axi_arlock,
          c3_s0_axi_arcache => c3_s0_axi_arcache,
          c3_s0_axi_arprot => c3_s0_axi_arprot,
          c3_s0_axi_arqos => c3_s0_axi_arqos,
          c3_s0_axi_arvalid => c3_s0_axi_arvalid,
          c3_s0_axi_arready => c3_s0_axi_arready,
          c3_s0_axi_rid => c3_s0_axi_rid,
          c3_s0_axi_rdata => c3_s0_axi_rdata,
          c3_s0_axi_rresp => c3_s0_axi_rresp,
          c3_s0_axi_rlast => c3_s0_axi_rlast,
          c3_s0_axi_rvalid => c3_s0_axi_rvalid,
          c3_s0_axi_rready => c3_s0_axi_rready
        );

end Behavioral;

